--Wrapper for luadll.e, by Jeremy Peterson.  Created: 11/30/2005
--Before using the lua functions, you must run Lua_Init to create a lua state,
--after you finish using the lua functions, you must run Lua_Close to close the
--lua state.
--Use Lua_RunString to run a string of commands, use Lua_RunFile to run a lua script.
--With these files you can use Lua as a scripting language for euphoria.
include dll.e
include machine.e

atom dll_handle, dll_proc1, dll_proc2, open_proc, close_proc, AS_handle
dll_handle = open_dll("luadll.dll")
dll_proc1 = define_c_proc(dll_handle, "_Lua_DoString@4", {C_POINTER})
dll_proc2 = define_c_proc(dll_handle, "_Lua_DoFile@4", {C_POINTER})
close_proc = define_c_proc(dll_handle, "_Close@0", {})
open_proc = define_c_proc(dll_handle, "_Open@0", {})

global procedure Lua_Init()
c_proc(open_proc, {})
end procedure

global procedure Lua_Close()
c_proc(close_proc, {})
end procedure
			      
global procedure Lua_RunString(sequence S)
AS_handle = allocate_string(S)
c_proc(dll_proc1, {AS_handle})
end procedure

global procedure Lua_RunFile(sequence S)
AS_handle = allocate_string(S)
c_proc(dll_proc2, {AS_handle})
end procedure